

#ifndef __OBJETO__
#define __OBJETO__

#ifndef WIN32
#include <GLUT/glut.h>
#endif

#ifdef WIN32
#include "GL/glut.h"
#endif


typedef struct Objeto {
    int tipo, id;
    int nroDeFilhos;
    bool eh_filho;
    Objeto *Filho;
	Objeto *Pai;
    GLfloat M[4][4];

    void setTipo(int t);

	void Init();
	void Rotate(float ang, float x, float y, float z);
	void Translate(float x, float y, float z);
	void Scale(float x, float y, float z);
	void Draw();
	void ImprimeMatriz(const char *msg);
	void InstanciaPonto(float PontoIN[3], float PontoOUT[3]);
	void AdicionaFilho(Objeto *filho);
	void RemoveFilho();

} Objeto;
#endif
